<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/PTree/operations.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/PTree/operations.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/PTree/operations.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line">//</span>
<a id="line2"></a><span class="lineno">  2</span><span class="line">// Copyright (C) 2004 Stefan Seefeld</span>
<a id="line3"></a><span class="lineno">  3</span><span class="line">// All rights reserved.</span>
<a id="line4"></a><span class="lineno">  4</span><span class="line">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span>
<a id="line5"></a><span class="lineno">  5</span><span class="line">// see the file COPYING for details.</span>
<a id="line6"></a><span class="lineno">  6</span><span class="line">//</span>
<a id="line7"></a><span class="lineno">  7</span><span class="line">#ifndef Synopsis_PTree_operations_hh_</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line">#define Synopsis_PTree_operations_hh_</span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line">#include &lt;Synopsis/PTree/Node.hh&gt;</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line">#include &lt;cassert&gt;</span>
<a id="line12"></a><span class="lineno"> 12</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="keyword">namespace</span> Synopsis</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line">{</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/PTree.html" title="namespace Synopsis::PTree">PTree</a></span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line">{</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree.html#operator_e_e_lconst.Node_A_cchar_r" title="function Synopsis::PTree::operator==(const Node&amp;,char)">operator ==</a> (<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> &amp;p, <span class="keyword">char</span> c);</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">inline <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree.html#operator_n_e_lconst.Node_A_cchar_r" title="function Synopsis::PTree::operator!=(const Node&amp;,char)">operator !=</a> (<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> &amp;p, <span class="keyword">char</span> c) { <span class="keyword">return</span> !operator == (<a href="" title="parameter p">p</a>, <a href="" title="parameter c">c</a>);}</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree.html#operator_e_e_lconst.Node_A_cconst.char_S_r" title="function Synopsis::PTree::operator==(const Node&amp;,const char*)">operator ==</a> (<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> &amp;p, <span class="keyword">const</span> <span class="keyword">char</span> *str);</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">inline <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree.html#operator_n_e_lconst.Node_A_cconst.char_S_r" title="function Synopsis::PTree::operator!=(const Node&amp;,const char*)">operator !=</a> (<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> &amp;p, <span class="keyword">const</span> <span class="keyword">char</span> *str) { <span class="keyword">return</span> !operator == (<a href="" title="parameter p">p</a>, <a href="" title="parameter str">str</a>);}</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree.html#operator_e_e_lconst.Node_A_cconst.Node_A_r" title="function Synopsis::PTree::operator==(const Node&amp;,const Node&amp;)">operator ==</a> (<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> &amp;p, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> &amp;q);</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">inline <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree.html#operator_n_e_lconst.Node_A_cconst.Node_A_r" title="function Synopsis::PTree::operator!=(const Node&amp;,const Node&amp;)">operator !=</a> (<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> &amp;p, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> &amp;q) { <span class="keyword">return</span> !operator == (<a href="" title="parameter p">p</a>, <a href="" title="parameter q">q</a>);}</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree.html#equal_lconst.Node_A_cconst.char_S_csize_t_r" title="function Synopsis::PTree::equal(const Node&amp;,const char*,size_t)">equal</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> &amp;p, <span class="keyword">const</span> <span class="keyword">char</span> *str, <a href="" title="typedef size_t">size_t</a> len);</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line"><span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree.html#equal_lconst.Node_S_cconst.Node_S_r" title="function Synopsis::PTree::equal(const Node*,const Node*)">equal</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *q);</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree.html#equiv_lconst.Node_S_cconst.Node_S_r" title="function Synopsis::PTree::equiv(const Node*,const Node*)">equiv</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p, <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *q);</span>
<a id="line26"></a><span class="lineno"> 26</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="comment">//. Return the last cons cell.</span></span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line"><span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#last_lconst.Node_S_r" title="function Synopsis::PTree::last(const Node*)">last</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="comment">//. Return the last cons cell.</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#last_lNode_S_r" title="function Synopsis::PTree::last(Node*)">last</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">inline <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#first_lconst.Node_S_r" title="function Synopsis::PTree::first(const Node*)">first</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p) { <span class="keyword">return</span> <a href="" title="parameter p">p</a> ? <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#car_l_rconst" title="member function Synopsis::PTree::Node::car()const">car</a>() : <span class="literal">0</span>;}</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">inline <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#first_lNode_S_r" title="function Synopsis::PTree::first(Node*)">first</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p) { <span class="keyword">return</span> <a href="" title="parameter p">p</a> ? <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#car_l_rconst" title="member function Synopsis::PTree::Node::car()const">car</a>() : <span class="literal">0</span>;}</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">inline <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#rest_lconst.Node_S_r" title="function Synopsis::PTree::rest(const Node*)">rest</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p) { <span class="keyword">return</span> <a href="" title="parameter p">p</a> ? <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#cdr_l_rconst" title="member function Synopsis::PTree::Node::cdr()const">cdr</a>() : <span class="literal">0</span>;}</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">inline <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#rest_lNode_S_r" title="function Synopsis::PTree::rest(Node*)">rest</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p) { <span class="keyword">return</span> <a href="" title="parameter p">p</a> ? <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#cdr_l_rconst" title="member function Synopsis::PTree::Node::cdr()const">cdr</a>() : <span class="literal">0</span>;}</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">inline <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#nth_lconst.Node_S_csize_t_r" title="function Synopsis::PTree::nth(const Node*,size_t)">nth</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p, <a href="" title="typedef size_t">size_t</a> n)</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">{</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">  <span class="keyword">while</span>(<a href="" title="parameter p">p</a> &amp;&amp; <a href="" title="parameter n">n</a>-- &gt; <span class="literal">0</span>) <a href="" title="parameter p">p</a> = <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#cdr_l_rconst" title="member function Synopsis::PTree::Node::cdr()const">cdr</a>();</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">  <span class="keyword">return</span> <a href="" title="parameter p">p</a> ? <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#car_l_rconst" title="member function Synopsis::PTree::Node::car()const">car</a>() : <span class="literal">0</span>;</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">}</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">inline <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#nth_lNode_S_csize_t_r" title="function Synopsis::PTree::nth(Node*,size_t)">nth</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p, <a href="" title="typedef size_t">size_t</a> n)</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">{</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">  <span class="keyword">while</span>(<a href="" title="parameter p">p</a> &amp;&amp; <a href="" title="parameter n">n</a>-- &gt; <span class="literal">0</span>) <a href="" title="parameter p">p</a> = <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#cdr_l_rconst" title="member function Synopsis::PTree::Node::cdr()const">cdr</a>();</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">  <span class="keyword">return</span> <a href="" title="parameter p">p</a> ? <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#car_l_rconst" title="member function Synopsis::PTree::Node::car()const">car</a>() : <span class="literal">0</span>;</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">}</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">inline <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#tail_lconst.Node_S_csize_t_r" title="function Synopsis::PTree::tail(const Node*,size_t)">tail</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p, <a href="" title="typedef size_t">size_t</a> k)</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">{</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">  <span class="keyword">while</span>(<a href="" title="parameter p">p</a> &amp;&amp; <a href="" title="parameter k">k</a>-- &gt; <span class="literal">0</span>) <a href="" title="parameter p">p</a> = <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#cdr_l_rconst" title="member function Synopsis::PTree::Node::cdr()const">cdr</a>();</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">  <span class="keyword">return</span> <a href="" title="parameter p">p</a>;</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">}</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">inline <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#tail_lNode_S_csize_t_r" title="function Synopsis::PTree::tail(Node*,size_t)">tail</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p, <a href="" title="typedef size_t">size_t</a> k)</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">{</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">  <span class="keyword">while</span>(<a href="" title="parameter p">p</a> &amp;&amp; <a href="" title="parameter k">k</a>-- &gt; <span class="literal">0</span>) <a href="" title="parameter p">p</a> = <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#cdr_l_rconst" title="member function Synopsis::PTree::Node::cdr()const">cdr</a>();</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">  <span class="keyword">return</span> <a href="" title="parameter p">p</a>;</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">}</span>
<a id="line55"></a><span class="lineno"> 55</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line"><span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#second_lconst.Node_S_r" title="function Synopsis::PTree::second(const Node*)">second</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#second_lNode_S_r" title="function Synopsis::PTree::second(Node*)">second</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line"><span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#third_lconst.Node_S_r" title="function Synopsis::PTree::third(const Node*)">third</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#third_lNode_S_r" title="function Synopsis::PTree::third(Node*)">third</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line"><span class="keyword">int</span> <a href="../../../Scopes/Synopsis/PTree.html#length_lconst.Node_S_r" title="function Synopsis::PTree::length(const Node*)">length</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line61"></a><span class="lineno"> 61</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">inline <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#cadr_lconst.Node_S_r" title="function Synopsis::PTree::cadr(const Node*)">cadr</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p) { <span class="keyword">return</span> <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#cdr_l_rconst" title="member function Synopsis::PTree::Node::cdr()const">cdr</a>()-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#car_l_rconst" title="member function Synopsis::PTree::Node::car()const">car</a>();}</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">inline <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#cadr_lNode_S_r" title="function Synopsis::PTree::cadr(Node*)">cadr</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p) { <span class="keyword">return</span> <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#cdr_l_rconst" title="member function Synopsis::PTree::Node::cdr()const">cdr</a>()-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#car_l_rconst" title="member function Synopsis::PTree::Node::car()const">car</a>();}</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">inline <span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#cddr_lconst.Node_S_r" title="function Synopsis::PTree::cddr(const Node*)">cddr</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p) { <span class="keyword">return</span> <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#cdr_l_rconst" title="member function Synopsis::PTree::Node::cdr()const">cdr</a>()-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#cdr_l_rconst" title="member function Synopsis::PTree::Node::cdr()const">cdr</a>();}</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">inline <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#cddr_lNode_S_r" title="function Synopsis::PTree::cddr(Node*)">cddr</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *p) { <span class="keyword">return</span> <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#cdr_l_rconst" title="member function Synopsis::PTree::Node::cdr()const">cdr</a>()-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#cdr_l_rconst" title="member function Synopsis::PTree::Node::cdr()const">cdr</a>();}</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line"><span class="comment">//. compute Caa..ar</span></span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line"><span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#ca_ar_lconst.Node_S_r" title="function Synopsis::PTree::ca_ar(const Node*)">ca_ar</a>(<span class="keyword">const</span> <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#ca_ar_lNode_S_r" title="function Synopsis::PTree::ca_ar(Node*)">ca_ar</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line69"></a><span class="lineno"> 69</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#cons_lNode_S_cNode_S_r" title="function Synopsis::PTree::cons(Node*,Node*)">cons</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *<a href="../../../Scopes/Synopsis/PTree.html#list_l_r" title="function Synopsis::PTree::list()">list</a>();</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *<a href="../../../Scopes/Synopsis/PTree.html#list_lNode_S_r" title="function Synopsis::PTree::list(Node*)">list</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *<a href="../../../Scopes/Synopsis/PTree.html#list_lNode_S_cNode_S_r" title="function Synopsis::PTree::list(Node*,Node*)">list</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *<a href="../../../Scopes/Synopsis/PTree.html#list_lNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::list(Node*,Node*,Node*)">list</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *<a href="../../../Scopes/Synopsis/PTree.html#list_lNode_S_cNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::list(Node*,Node*,Node*,Node*)">list</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *<a href="../../../Scopes/Synopsis/PTree.html#list_lNode_S_cNode_S_cNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::list(Node*,Node*,Node*,Node*,Node*)">list</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *<a href="../../../Scopes/Synopsis/PTree.html#list_lNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::list(Node*,Node*,Node*,Node*,Node*,Node*)">list</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *<a href="../../../Scopes/Synopsis/PTree.html#list_lNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::list(Node*,Node*,Node*,Node*,Node*,Node*,Node*)">list</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *,</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">	   <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *<a href="../../../Scopes/Synopsis/PTree.html#list_lNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::list(Node*,Node*,Node*,Node*,Node*,Node*,Node*,Node*)">list</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *,</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">	   <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#copy_lNode_S_r" title="function Synopsis::PTree::copy(Node*)">copy</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#append_lNode_S_cNode_S_r" title="function Synopsis::PTree::append(Node*,Node*)">append</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#replace_all_lNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::replace_all(Node*,Node*,Node*)">replace_all</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#subst_lNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::subst(Node*,Node*,Node*)">subst</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#subst_lNode_S_cNode_S_cNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::subst(Node*,Node*,Node*,Node*,Node*)">subst</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#subst_lNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::subst(Node*,Node*,Node*,Node*,Node*,Node*,Node*)">subst</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *,</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">	    <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#shallow_subst_lNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::shallow_subst(Node*,Node*,Node*)">shallow_subst</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#shallow_subst_lNode_S_cNode_S_cNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::shallow_subst(Node*,Node*,Node*,Node*,Node*)">shallow_subst</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#shallow_subst_lNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::shallow_subst(Node*,Node*,Node*,Node*,Node*,Node*,Node*)">shallow_subst</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *,</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">		    <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#shallow_subst_lNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::shallow_subst(Node*,Node*,Node*,Node*,Node*,Node*,Node*,Node*,Node*)">shallow_subst</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *,</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">		    <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#subst_sublist_lNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::subst_sublist(Node*,Node*,Node*)">subst_sublist</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line"><span class="comment">/* they cause side-effect */</span></span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#nconc_lNode_S_cNode_S_r" title="function Synopsis::PTree::nconc(Node*,Node*)">nconc</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#nconc_lNode_S_cNode_S_cNode_S_r" title="function Synopsis::PTree::nconc(Node*,Node*,Node*)">nconc</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">template &lt;typename N&gt; N *<a href="../../../Scopes/Synopsis/PTree.html#nconc_lN_S_cNode_S_r" title="function template Synopsis::PTree::nconc(N*,Node*)">nconc</a>(N *p, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *q) </span>
<a id="line101"></a><span class="lineno">101</span><span class="line">{</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">  <a href="" title="macro call">assert</a>(p);</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree.html#last_lconst.Node_S_r" title="function Synopsis::PTree::last(const Node*)">last</a>(<a href="" title="parameter p">p</a>)-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#set_cdr_lNode_S_r" title="member function Synopsis::PTree::Node::set_cdr(Node*)">set_cdr</a>(<a href="" title="parameter q">q</a>);</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">  <span class="keyword">return</span> <a href="" title="parameter p">p</a>;</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">}</span>
<a id="line106"></a><span class="lineno">106</span>
<a id="line107"></a><span class="lineno">107</span><span class="line"><a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *<a href="../../../Scopes/Synopsis/PTree.html#snoc_lNode_S_cNode_S_r" title="function Synopsis::PTree::snoc(Node*,Node*)">snoc</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *);</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">template &lt;typename N&gt; N *<a href="../../../Scopes/Synopsis/PTree.html#snoc_lN_S_cNode_S_r" title="function template Synopsis::PTree::snoc(N*,Node*)">snoc</a>(N *p, <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *q)</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">{</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">  <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/PTree.html#nconc_lNode_S_cNode_S_r" title="function Synopsis::PTree::nconc(Node*,Node*)">nconc</a>(<a href="" title="parameter p">p</a>, <a href="../../../Scopes/Synopsis/PTree.html#cons_lNode_S_cNode_S_r" title="function Synopsis::PTree::cons(Node*,Node*)">cons</a>(<a href="" title="parameter q">q</a>, <span class="literal">0</span>));</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">}</span>
<a id="line112"></a><span class="lineno">112</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">}</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">}</span>
<a id="line115"></a><span class="lineno">115</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:02 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
